# Useful resources:
# http://www.bravegnu.org/blog/make-to-scons.html

#Also useful is the "out of date" design document:
#https://scons.org/doc/production/PDF/scons-design.pdf
#(keeping in mind that the examples show lowercase variable names that actually need to be UPPERCASE)
# Command (target, source, command)

from urllib.request import urlopen

# for now: unconditionally download the pad
# todo: use etherdump to (conditionally) pull the pad(s) ;)
for filename in ["tic80-manual.md", "tic80-manual.css"]:
    fin = urlopen(f"https://pad.xpub.nl/p/{filename}/export/txt")
    with open(filename, "w") as fout:
        print (fin.read().decode(), file=fout)

# Command("tic80-manual.html", "tic80-manual.md", "pandoc $SOURCE --from markdown --to html5 --standalone -o $TARGET")

# 1. create a custom pandoc Builder
# Pandoc = Builder(action="pandoc $SOURCE --from markdown --to html5 --self-contained -o $TARGET")
HTMLFromMarkdown = Builder(action="pandoc ${SOURCES[0]} --css ${SOURCES[1]} --from markdown-blank_before_header --to html5 --self-contained --toc --toc-depth=2 -o $TARGET")
PDFFromMarkdown = Builder(action="pandoc ${SOURCES[0]} --css ${SOURCES[1]} --from markdown-blank_before_header --pdf-engine weasyprint --toc --toc-depth=2 -o $TARGET")

# 2. Make an environment & register the builders
env = Environment()
env.Append(BUILDERS={
    "HTMLFromMarkdown": HTMLFromMarkdown,
    "PDFFromMarkdown": PDFFromMarkdown
})

# 3. Use the env.Builder to designate a target(s) + source(s)
env.HTMLFromMarkdown("tic80-manual.html", ["tic80-manual.md", "tic80-manual.css"])
env.PDFFromMarkdown("tic80-manual.pdf", ["tic80-manual.md", "tic80-manual.css"])

